<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>{{ disciplina.descripcion }}</strong>
    </div>
    <div class="contenedorPrincipal">
      <div>
        <h1 class="tituloPagina">{{ disciplina.descripcion }}</h1>
      </div>
      <Filters ref="filters" />
      <v-row>
        <v-col :cols="12" :xl="6" class="pr-8">
          <CalificacionFinalYDistribucionCalificaciones
            :global-filters-parent="globalFilters"
            :methods-semaforo-parent="methodsSemaforo"
          />
        </v-col>
        <v-col :cols="12" :xl="6" class="pl-8">
          <CumplimientoDisciplinaPorNegocio005
            :global-filters-parent="globalFilters"
            :methods-semaforo-parent="methodsSemaforo"
          />
          <DistribucionCumplimientoCecoPorNivelRegion010
            :global-filters-parent="globalFilters"
            :methods-semaforo-parent="methodsSemaforo"
          />
        </v-col>
      </v-row>
      <v-row>
        <v-col>
          <DistribucionCumplimientoCecoPorNivel007
            :global-filters-parent="globalFilters"
            :methods-semaforo-parent="methodsSemaforo"
            :zoom-search-ceco="zoomSearchCeco"
          />
          <CumplimientoCalificacionDisciplinaPuntosContactoNegocio015
            :global-filters-parent="globalFilters"
            :methods-semaforo-parent="methodsSemaforo"
          />
          <CumplimientoCalificacionDisciplinaPuntosContacto009
            :global-filters-parent="globalFilters"
            :methods-semaforo-parent="methodsSemaforo"
          />
          <DistribucionCumplimientoCecoNegocioPorNivel016
            :global-filters-parent="globalFilters"
            :methods-semaforo-parent="methodsSemaforo"
          />
        </v-col>
      </v-row>
      <v-row>
        <v-col>
          <CumplimientoPuntajePorNegocio006
            :global-filters-parent="globalFilters"
            :methods-semaforo-parent="methodsSemaforo"
          />
        </v-col>
      </v-row>
      <!--<v-row> 
        <v-col>
          <CumplimientoSeccionPorNivel008
            :global-filters-parent="globalFilters"
            :methods-semaforo-parent="methodsSemaforo"
          />
        </v-col>
      </v-row>-->
      <v-row
        v-if="
          disciplina.id_disciplina == 5 &&
            globalFilters &&
            globalFilters.final_filters.id_negocio != 0 &&
            globalFilters.final_filters.nivel_geografico != 4 &&
            !(
              globalFilters.final_filters.numero_periodo == 1 &&
              globalFilters.final_filters.anio == 2020
            )
        "
      >
        <v-col>
          <CumplimientoSeccionPorNivelNegocio017
            :global-filters-parent="globalFilters"
            :methods-semaforo-parent="methodsSemaforo"
          />
        </v-col>
      </v-row>
      <v-row>
        <!--<v-col>
          PENDIENTE
          <CumplimientoPuntajePorNivel011
            :global-filters-parent="globalFilters"
            :methods-semaforo-parent="methodsSemaforo"
          />
        </v-col>-->
      </v-row>
      <v-row>
        <v-col>
          <IncumplimientosImperdonables012
            :global-filters-parent="globalFilters"
            :methods-semaforo-parent="methodsSemaforo"
          />
        </v-col>
      </v-row>
      <!--<v-row
        v-if="
          disciplina.id_disciplina == 5 &&
            globalFilters &&
            globalFilters.final_filters.id_negocio != 0 &&
            globalFilters.final_filters.nivel_geografico == 4
        "
      >
        <v-col>
          <div class="text-center">
            <v-btn
              :disabled="isDownloading"
              @click="linkDownloadFile()"
              color="primary"
              >Descargar Excel de la información a nivel nacional</v-btn
            >
          </div>
        </v-col>
      </v-row>-->
      <v-row>
        <v-col>
          <div class="text-center">
            <v-btn v-if="showBotonDescarga"
              :disabled="isDownloading"
              @click="descargarReporteMedicion()"
              color="primary"
              >Descargar Excel de la información</v-btn
            >
          </div>
        </v-col>
      </v-row>
    </div>
    <Semaforo />
    <v-dialog v-model="showDescargaReporte" max-width="1000px">
      <v-card>
        <v-toolbar dense color="grey">
          <v-spacer></v-spacer>
          <v-btn icon color="white" @click="showDescargaReporte = false">
            <v-icon>mdi-close</v-icon>
          </v-btn>
        </v-toolbar>
        <DescargaExcelMedicion :globalFilters="this.globalFilters" />
      </v-card>
    </v-dialog>
  </div>
</template>
<style scoped>
.tituloPagina {
  font-family: "Avenir_Next_Bold";
  font-size: 22px;
}
.contenedorPrincipal {
  padding: 20px 65px;
}
</style>
<script>
import Filters from "@/views/secure/sistema-informacion/dashboards/commons/Filtros.vue";
import Semaforo from "@/views/secure/sistema-informacion/dashboards/commons/graficos/Semaforo.vue";
import CalificacionFinalYDistribucionCalificaciones from "@/views/secure/sistema-informacion/dashboards/commons/graficos/CalificacionFinalYDistribucionCalificaciones.vue";
import CumplimientoDisciplinaPorNegocio005 from "@/views/secure/sistema-informacion/dashboards/commons/graficos/CumplimientoDisciplinaPorNegocio005.vue";
import DistribucionCumplimientoCecoPorNivel007 from "@/views/secure/sistema-informacion/dashboards/commons/graficos/DistribucionCumplimientoCecoPorNivel007.vue";
import CumplimientoCalificacionDisciplinaPuntosContacto009 from "@/views/secure/sistema-informacion/dashboards/commons/graficos/CumplimientoCalificacionDisciplinaPuntosContacto009.vue";
import DistribucionCumplimientoCecoPorNivelRegion010 from "@/views/secure/sistema-informacion/dashboards/commons/graficos/CumplimientoDisciplinaPuntoContacto010.vue";
import CumplimientoPuntajePorNegocio006 from "@/views/secure/sistema-informacion/dashboards/commons/graficos/CumplimientoPuntajePorNegocio006.vue";
//import CumplimientoSeccionPorNivel008 from "@/views/secure/sistema-informacion/dashboards/commons/graficos/CumplimientoSeccionPorNivel008.vue";
//import CumplimientoPuntajePorNivel011 from "@/views/secure/sistema-informacion/dashboards/commons/graficos/CumplimientoPuntajePorNivel011.vue";
import IncumplimientosImperdonables012 from "@/views/secure/sistema-informacion/dashboards/commons/graficos/IncumplimientosImperdonables012.vue";
import CumplimientoCalificacionDisciplinaPuntosContactoNegocio015 from "@/views/secure/sistema-informacion/dashboards/commons/graficos/CumplimientoCalificacionDisciplinaPuntosContactoNegocio015.vue";
import DistribucionCumplimientoCecoNegocioPorNivel016 from "@/views/secure/sistema-informacion/dashboards/commons/graficos/DistribucionCumplimientoCecoNegocioPorNivel016.vue";
import CumplimientoSeccionPorNivelNegocio017 from "@/views/secure/sistema-informacion/dashboards/commons/graficos/CumplimientoSeccionPorNivelNegocio017.vue";
import DescargaExcelMedicion from "@/views/secure/sistema-informacion/dashboards/detalle-disciplina/DescargaExcelMedicion.vue";
import store from "@/store";
import axios from "axios";
import FileSaver from "file-saver";
import * as am4core from "@amcharts/amcharts4/core";
import * as am4charts from "@amcharts/amcharts4/charts";
import am4themes_animated from "@amcharts/amcharts4/themes/animated";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
am4core.useTheme(am4themes_animated);

export default {
  name: "Component-DetalleDisciplinaNivelNacional",
  components: {
    Filters,
    Semaforo,
    CalificacionFinalYDistribucionCalificaciones,
    CumplimientoDisciplinaPorNegocio005,
    DistribucionCumplimientoCecoPorNivel007,
    CumplimientoCalificacionDisciplinaPuntosContacto009,
    CumplimientoPuntajePorNegocio006,
    //CumplimientoSeccionPorNivel008,
    CumplimientoSeccionPorNivelNegocio017,
    //CumplimientoPuntajePorNivel011,
    IncumplimientosImperdonables012,
    DistribucionCumplimientoCecoPorNivelRegion010,
    CumplimientoCalificacionDisciplinaPuntosContactoNegocio015,
    DistribucionCumplimientoCecoNegocioPorNivel016,
    DescargaExcelMedicion
  },
  data() {
    return {
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Sistema de Información",
          disabled: false,
          exact: true,
          to: {
            name: "sistema_informacion"
          }
        },
        {
          text: "Dashboard",
          disabled: true
        },
        {
          text: "Disciplinas",
          disabled: false,
          exact: true,
          to: {
            name: "sistema_informacion_dashboard_disciplinas"
          }
        }
      ],
      globalFilters: null,
      zoomSearchCeco: null,
      isDownloading: false,
      disciplina: null,
      methodsSemaforo: null,
      showDescargaReporte:false,
      showBotonDescarga:false
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    }
  },
  methods: {
    listenSearchConsulta(globalFilters) {
      this.globalFilters = globalFilters;
    },
    init() {
      this.breadcrumbs.push({
        text: this.disciplina.descripcion,
        disabled: true
      });
    },
    listenSemaforo(methodsSemaforo) {
      this.methodsSemaforo = methodsSemaforo;
    },
    linkDownloadFile() {
      this.isDownloading = true;
      const self = this;
      const serviceName = "/file/secure/read/";
      const idNegocio = this.globalFilters.final_filters.id_negocio;
      const pathLocationReport =
        "/franquicia/plataforma_franquicia/resources/reportes/medicion/";
      let nameReport;
      if (idNegocio == 1) {
        nameReport = "Reporte_Disciplina7S_BAZ.xlsx";
      } else if (idNegocio == 2) {
        nameReport = "Reporte_Disciplina7S_EKT.xlsx";
      } else if (idNegocio == 3) {
        nameReport = "Reporte_Disciplina7S_PPR.xlsx";
      } else if (idNegocio == 4) {
        nameReport = "Reporte_Disciplina7S_GEK.xlsx";
      } else if (idNegocio == 5) {
        nameReport = "Reporte_Disciplina7S_CYC.xlsx";
      } else if (idNegocio == 6) {
        nameReport = "Reporte_Disciplina7S_CYF.xlsx";
      }
      let fullPath = serviceCommons.stringToBase64(
        pathLocationReport + nameReport
      );
      const url = serviceName + fullPath;
      axios({
        url: url,
        responseType: "blob"
      })
        .then((response) => {
          FileSaver.saveAs(response.data, nameReport);
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isDownloading = true;
        });
    },
    descargarReporteMedicion(){

      let user = serviceLocalStorage.userToken();

      let tienePerfil = false;

      store.state.perfiles.forEach((item) => {
        if (item.perfil.id_perfil == 331) {
          tienePerfil = true;
        }
      });

      if(tienePerfil){
        this.showDescargaReporte = true;
      }else{
        this.downloadReportExcel();
      }
    },

    downloadReportExcel() {
      this.isDownloading = true;
      const self = this;

      let url = "/reporte/medicion/secure/get";

      if(this.globalFilters.final_filters.id_disciplina == 5 || this.globalFilters.final_filters.id_disciplina == 24 ){
        url = "/reporte/medicion/7s/secure/get";
        
      }
      
      axios({
        method: "post",
        url: url,
        responseType: "blob",
        data: this.globalFilters.final_filters
      })
        .then((response) => {
          if (response.headers["content-type"] !== "application/json") {
            FileSaver.saveAs(response.data, response.headers["file-name"]);
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isDownloading = false;
        });
       
    }

  },
  mounted() {
    this.$root.$on("rangoloaded", this.listenSemaforo);
    this.$root.$on("searchconsulta", this.listenSearchConsulta);
  },
  created() {
    if (this.$route.params.disciplina) {
      this.disciplina = this.serviceCommons.base64ToObject(
        this.$route.params.disciplina
      );
    }

    let user = serviceLocalStorage.userToken();

    let tienePerfil = false;

    store.state.perfiles.forEach((item) => {
        if (item.perfil.id_perfil == 331) {
          tienePerfil = true;
        }
    });

      if(tienePerfil){
        this.showBotonDescarga = true;
      }else{
        this.showBotonDescarga = false;
      }

    this.init();
  }
};
</script>
